       PROCESS DLL,EXP,TEST(NOSEP)

      ******************************************************************
      * Licensed materials - Property of IBM                           *
      * 5724-T07 Copyright IBM Corp. 2012                              *
      * All rights reserved                                            *
      * US Government users restricted rights  -  Use, duplication or  *
      * disclosure restricted by GSA ADP schedule contract with IBM    *
      * Corp.                                                          *
      *                                                                *
      * IBM Rational Developer for System z (RDz)                      *
      * IBM z/OS Automated Unit Testing Framework (zUnit)              *
      * Enterprise COBOL zUnit Test Case Sample AZUTC001               *
      * AZUTC001.cbl                                                   *
      *                                                                *
      * This file contains a zUnit test case that was created using    *
      * the Enterprise COBOL new zUnit Test Case wizard. The generated *
      * test case was modified to perform multiple tests against       *
      * the program ANAGRAM which is part of the Enterprise COBOL      *
      * zUnit test case sample AZUTC001. In each test, if ANAGRAM      *
      * fails to detect a valid anagram, the test is failed using an   *
      * assertion.                                                     *
      *                                                                *
      * @since   8.5.0.0                                               *
      * @version 9.0.0.0                                               *
      ******************************************************************

      *+---------------------------------------------------------------+
      *| Product: IBM Rational Developer for System z                  |
      *| Component: IBM z/OS Automated Unit Testing Framework (zUnit)  |
      *|   for Enterprise COBOL and PL/I                               |
      *| Program: Enterprise COBOL zUnit Test Case                     |
      *| Date Generated: 03/13/2013 04:10 PM                           |
      *| ID: 9feb6a09-faf7-4b83-85b4-75664938e53f                      |
      *+---------------------------------------------------------------+
      *+---------------------------------------------------------------+
      *| AZUTC001                                                      |
      *|     This program is immediately called by the IBM             |
      *|     z/OS Automated Unit Testing Framework (zUnit)             |
      *|     Test Runner to allow for initialization of the            |
      *|     Test Case. Upon return from this program, the             |
      *|     Test Runner will attempt to call the ADDTESTS             |
      *|     program.                                                  |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| Note: this program does not require editing.                  |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'AZUTC001'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 CBLTESTC-ID PIC X(36)
            VALUE '9feb6a09-faf7-4b83-85b4-75664938e53f'.
       1 CBLTESTC-NAME PIC X(35)
            VALUE 'AZUTC001 Test Case Written In COBOL'.
       1 CBLTESTC-ID-LEN PIC S9(9) COMP-5.
       1 CBLTESTC-NAME-LEN PIC S9(9) COMP-5.
       1 CBLTESTC-SETUP    FUNCTION-POINTER.
       1 CBLTESTC-TEARDOWN FUNCTION-POINTER.
       1 CBLTESTC-ADDTESTS FUNCTION-POINTER.
       LINKAGE SECTION.
       1 TEST-CASE-PTR POINTER.
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR.
      * This program does not require editing.
           MOVE LENGTH OF CBLTESTC-ID TO CBLTESTC-ID-LEN
           MOVE LENGTH OF CBLTESTC-NAME TO CBLTESTC-NAME-LEN
           SET CBLTESTC-ADDTESTS TO ENTRY 'ADDTESTS'
           SET CBLTESTC-SETUP    TO ENTRY 'SETUP'
           SET CBLTESTC-TEARDOWN TO ENTRY 'TEARDOWN'
           CALL 'AZUTCINI' USING
               BY VALUE     TEST-CASE-PTR
               BY REFERENCE CBLTESTC-ID
               BY VALUE     CBLTESTC-ID-LEN
               BY REFERENCE CBLTESTC-NAME
               BY VALUE     CBLTESTC-NAME-LEN
               BY VALUE     CBLTESTC-ADDTESTS
               BY VALUE     CBLTESTC-SETUP
               BY VALUE     CBLTESTC-TEARDOWN
           .
        END PROGRAM 'AZUTC001'.
      *+---------------------------------------------------------------+
      *| ADDTESTS                                                      |
      *|     This program is called by the zUnit Test Runner           |
      *|     to allow for adding Tests to the Test Case. Upon          |
      *|     return from this program, the Test Runner will            |
      *|     call the added Tests, surrounding each with calls         |
      *|     to the SETUP and TEARDOWN programs.                       |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'ADDTESTS'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 TEST-ENTRY     FUNCTION-POINTER.
       1 TEST-NAME      PIC X(254).
       1 TEST-NAME-LEN  PIC S9(9) COMP-5.
       LINKAGE SECTION.
       1 TEST-CASE-PTR POINTER.
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR.
      * TODO: Add Tests to the Test Case.
           SET TEST-ENTRY TO ENTRY 'TEST001'
           MOVE 'AZUTC001.test001' TO TEST-NAME
           MOVE 16 TO TEST-NAME-LEN
           CALL 'AZUTCADD' USING
               BY VALUE     TEST-CASE-PTR
               BY VALUE     TEST-ENTRY
               BY REFERENCE TEST-NAME
               BY VALUE     TEST-NAME-LEN
           SET TEST-ENTRY TO ENTRY 'TEST002'
           MOVE 'AZUTC001.test002' TO TEST-NAME
           MOVE 16 TO TEST-NAME-LEN
           CALL 'AZUTCADD' USING
               BY VALUE     TEST-CASE-PTR
               BY VALUE     TEST-ENTRY
               BY REFERENCE TEST-NAME
               BY VALUE     TEST-NAME-LEN
           SET TEST-ENTRY TO ENTRY 'TEST003'
           MOVE 'AZUTC001.test003' TO TEST-NAME
           MOVE 16 TO TEST-NAME-LEN
           CALL 'AZUTCADD' USING
               BY VALUE     TEST-CASE-PTR
               BY VALUE     TEST-ENTRY
               BY REFERENCE TEST-NAME
               BY VALUE     TEST-NAME-LEN
           SET TEST-ENTRY TO ENTRY 'TEST004'
           MOVE 'AZUTC001.test004' TO TEST-NAME
           MOVE 16 TO TEST-NAME-LEN
           CALL 'AZUTCADD' USING
               BY VALUE     TEST-CASE-PTR
               BY VALUE     TEST-ENTRY
               BY REFERENCE TEST-NAME
               BY VALUE     TEST-NAME-LEN
           .
       END PROGRAM 'ADDTESTS'.
      *+---------------------------------------------------------------+
      *| SETUP                                                         |
      *|     This program is invoked by the zUnit Test Runner          |
      *|     prior to each Test to allow for allocation of             |
      *|     resources (e.g., memory, connections) that are            |
      *|     required to create the Test Fixture.                      |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (output),                             |
      *|     A pointer-by-reference in which to store the address      |
      *|     of a user-defined structure that represents the Test      |
      *|     Fixture. References to all allocated resources should     |
      *|     be maintained in this structure so that they may be       |
      *|     accessed in the respective Test program, and released     |
      *|     in the TEARDOWN program.                                  |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'SETUP'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 CEEGTST-SIZE PIC S9(9) COMP-5.
       1 CEEGTST-HEAP PIC S9(9) COMP-5.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       LINKAGE SECTION.
       COPY ANAGRAM.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY REFERENCE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
           EVALUATE TEST-NAME(1:TEST-NAME-LEN)
              WHEN 'AZUTC001.test001'
      *         setup a valid anagram for test AZUTC001.test001
                PERFORM ALLOCATE-ANAGRMIO
                MOVE 15 TO FIRST-WORD-LEN
                MOVE 'Eleven plus two'
                  TO FIRST-WORD(1:FIRST-WORD-LEN)
                MOVE 15 TO SECOND-WORD-LEN
                MOVE 'Twelve plus one'
                  TO SECOND-WORD(1:SECOND-WORD-LEN)
              WHEN 'AZUTC001.test002'
      *         setup a valid anagram for test AZUTC001.test002
                PERFORM ALLOCATE-ANAGRMIO
                MOVE 14 TO FIRST-WORD-LEN
                MOVE 'The Morse code'
                  TO FIRST-WORD(1:FIRST-WORD-LEN)
                MOVE 14 TO SECOND-WORD-LEN
                MOVE 'Here come dots'
                  TO SECOND-WORD(1:SECOND-WORD-LEN)
      *         SET TEST-FIXTURE-PTR TO NULL
              WHEN 'AZUTC001.test003'
      *         setup a valid anagram for test AZUTC001.test003
                PERFORM ALLOCATE-ANAGRMIO
                MOVE 13 TO FIRST-WORD-LEN
                MOVE 'Snooze alarms'
                  TO FIRST-WORD(1:FIRST-WORD-LEN)
                MOVE 16 TO SECOND-WORD-LEN
                MOVE 'Alas! No more Zs'
                  TO SECOND-WORD(1:SECOND-WORD-LEN)
              WHEN 'AZUTC001.test004'
      *         setup a valid anagram for test AZUTC001.test004
                PERFORM ALLOCATE-ANAGRMIO
                MOVE 10 TO FIRST-WORD-LEN
                MOVE 'Astronomer'
                  TO FIRST-WORD(1:FIRST-WORD-LEN)
                MOVE 11 TO SECOND-WORD-LEN
                MOVE 'Moon starer'
                  TO SECOND-WORD(1:SECOND-WORD-LEN)
           END-EVALUATE
           GOBACK
           .
       ALLOCATE-ANAGRMIO.
      * allocate an instance of struct ANAGRMIO
           INITIALIZE CEEGTST-HEAP CEEGTST-SIZE
           MOVE LENGTH OF ANAGRMIO TO CEEGTST-SIZE
           CALL 'CEEGTST' USING CEEGTST-HEAP CEEGTST-SIZE
                TEST-FIXTURE-PTR OMITTED
           SET ADDRESS OF ANAGRMIO TO TEST-FIXTURE-PTR
           INITIALIZE ANAGRMIO
           .
       END PROGRAM 'SETUP'.
      *+---------------------------------------------------------------+
      *| TEARDOWN                                                      |
      *|     This program is invoked by the zUnit Test Runner          |
      *|     after each Test to allow for releasing resources          |
      *|     (e.g., memory, connection) which were allocated           |
      *|     during creation of the Test Fixture in the SETUP          |
      *|     program.                                                  |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'TEARDOWN'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       LINKAGE SECTION.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
           EVALUATE TEST-NAME(1:TEST-NAME-LEN)
              WHEN 'AZUTC001.test001'
      *         free test fixture for 'AZUTC001.test001'
                CALL 'CEEFRST' USING TEST-FIXTURE-PTR OMITTED
              WHEN 'AZUTC001.test002'
      *         free test fixture for 'AZUTC001.test002'
                CALL 'CEEFRST' USING TEST-FIXTURE-PTR OMITTED
              WHEN 'AZUTC001.test003'
      *         free test fixture for 'AZUTC001.test003'
                CALL 'CEEFRST' USING TEST-FIXTURE-PTR OMITTED
              WHEN 'AZUTC001.test004'
      *         free test fixture for 'AZUTC001.test004'
                CALL 'CEEFRST' USING TEST-FIXTURE-PTR OMITTED
           END-EVALUATE
           .
       END PROGRAM 'TEARDOWN'.
      *+---------------------------------------------------------------+
      *| TEST001                                                       |
      *|     Test a valid anagram.                                     |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'TEST001'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       LINKAGE SECTION.
       COPY ANAGRAM.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
      *    display test name on entry
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Started...'
      *    establish addressability to test fixture
           SET ADDRESS OF ANAGRMIO TO TEST-FIXTURE-PTR
      *    test a valid anagram
           CALL 'ANAGRAM' USING ANAGRMIO
           IF NOT-ANAGRAM OR INPUT-ERROR
              MOVE 1 TO FAIL-MESSAGE-LEN
              STRING
                 'ANAGRAM failed to detect that "'
                 FIRST-WORD(1:FIRST-WORD-LEN)
                 '" is an anagram of "'
                 SECOND-WORD(1:SECOND-WORD-LEN) '"'
                 DELIMITED BY SIZE INTO FAIL-MESSAGE-TXT
                 WITH POINTER FAIL-MESSAGE-LEN
              END-STRING
              SUBTRACT 1 FROM FAIL-MESSAGE-LEN
      *       throw an assertion exception (ends test)
              CALL 'AZUASTFM' USING BY VALUE TEST-CASE-PTR
                              BY REFERENCE FAIL-MESSAGE-TXT
                              BY VALUE FAIL-MESSAGE-LEN
           END-IF
      * display test name on exit
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Successful.'
           .
       END PROGRAM 'TEST001'.
      *+---------------------------------------------------------------+
      *| TEST002                                                       |
      *|     Test a valid anagram.                                     |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'TEST002'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       LINKAGE SECTION.
       COPY ANAGRAM.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
      *    display test name on entry
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Started...'
      *    establish addressability to test fixture
           SET ADDRESS OF ANAGRMIO TO TEST-FIXTURE-PTR
      *    test a valid anagram
           CALL 'ANAGRAM' USING ANAGRMIO
           IF NOT-ANAGRAM OR INPUT-ERROR
              MOVE 1 TO FAIL-MESSAGE-LEN
              STRING
                 'ANAGRAM failed to detect that '
                 FIRST-WORD(1:FIRST-WORD-LEN)
                 ' is an anagram of '
                 SECOND-WORD(1:SECOND-WORD-LEN)
                 DELIMITED BY SIZE INTO FAIL-MESSAGE-TXT
                 WITH POINTER FAIL-MESSAGE-LEN
              END-STRING
              SUBTRACT 1 FROM FAIL-MESSAGE-LEN
      *       throw an assertion exception (ends test)
              CALL 'AZUASTFM' USING BY VALUE TEST-CASE-PTR
                              BY REFERENCE FAIL-MESSAGE-TXT
                              BY VALUE FAIL-MESSAGE-LEN
           END-IF
      *    display test name on exit
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Successful.'
           .
       END PROGRAM 'TEST002'.
      *+---------------------------------------------------------------+
      *| TEST003                                                       |
      *|     Test a valid anagram.                                     |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'TEST003'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       LINKAGE SECTION.
       COPY ANAGRAM.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
      *    display test name on entry
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Started...'
      *    establish addressability to test fixture
           SET ADDRESS OF ANAGRMIO TO TEST-FIXTURE-PTR
      *    test a valid anagram
           CALL 'ANAGRAM' USING ANAGRMIO
           IF NOT-ANAGRAM OR INPUT-ERROR
              MOVE 1 TO FAIL-MESSAGE-LEN
              STRING
                 'ANAGRAM failed to detect that '
                 FIRST-WORD(1:FIRST-WORD-LEN)
                 ' is an anagram of '
                 SECOND-WORD(1:SECOND-WORD-LEN)
                 DELIMITED BY SIZE INTO FAIL-MESSAGE-TXT
                 WITH POINTER FAIL-MESSAGE-LEN
              END-STRING
              SUBTRACT 1 FROM FAIL-MESSAGE-LEN
      *       throw an assertion exception (ends test)
              CALL 'AZUASTFM' USING BY VALUE TEST-CASE-PTR
                              BY REFERENCE FAIL-MESSAGE-TXT
                              BY VALUE FAIL-MESSAGE-LEN
           END-IF
      *    display test name on exit
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Successful.'
           .
       END PROGRAM 'TEST003'.
      *+---------------------------------------------------------------+
      *| TEST004                                                       |
      *|     Test a valid anagram.                                     |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'TEST004'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       LINKAGE SECTION.
       COPY ANAGRAM.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
      *    display test name on entry
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Started...'
      *    establish addressability to test fixture
           SET ADDRESS OF ANAGRMIO TO TEST-FIXTURE-PTR
      *    test a valid anagram
           CALL 'ANAGRAM' USING ANAGRMIO
           IF NOT-ANAGRAM OR INPUT-ERROR
              MOVE 1 TO FAIL-MESSAGE-LEN
              STRING
                 'ANAGRAM failed to detect that '
                 FIRST-WORD(1:FIRST-WORD-LEN)
                 ' is an anagram of '
                 SECOND-WORD(1:SECOND-WORD-LEN)
                 DELIMITED BY SIZE INTO FAIL-MESSAGE-TXT
                 WITH POINTER FAIL-MESSAGE-LEN
              END-STRING
              SUBTRACT 1 FROM FAIL-MESSAGE-LEN
      *       throw an assertion exception (ends test)
              CALL 'AZUASTFM' USING BY VALUE TEST-CASE-PTR
                              BY REFERENCE FAIL-MESSAGE-TXT
                              BY VALUE FAIL-MESSAGE-LEN
           END-IF
      *    display test name on exit
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Successful.'
           .
       END PROGRAM 'TEST004'.